﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core;
using Infragistics.UltraChart.Core.Primitives;
using System.Diagnostics;
using Infragistics.UltraChart.Resources;
using Infragistics.UltraChart.Shared.Styles;
using System.Collections;

namespace _126447
{
    public partial class Form1 : Form
    {
        Box latestP = null;
        //column spasing
        int offset = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            ((ColumnChartAppearance)ultraChart1.CompositeChart.ChartLayers[0].ChartTypeAppearance).ColumnSpacing = 3;
            ((ColumnChartAppearance)ultraChart1.CompositeChart.ChartLayers[1].ChartTypeAppearance).ColumnSpacing = 3;


            ultraChart1.CompositeChart.Series.Add(GetNumericSeriesBound("Column A"));
            ultraChart1.CompositeChart.ChartLayers[0].Series.Add(ultraChart1.CompositeChart.Series[0]);

            ultraChart1.CompositeChart.Series.Add(GetNumericSeriesBound("Column B"));
            ultraChart1.CompositeChart.ChartLayers[1].Series.Add(ultraChart1.CompositeChart.Series[1]);


            this.ultraChart1.Tooltips.FormatString = "<MyDATA_VALUE>";

            Hashtable MyLabelHashTable = new Hashtable();
            MyLabelHashTable.Add("MyDATA_VALUE", new MyLabelRenderer());
            this.ultraChart1.LabelHash = MyLabelHashTable;

            offset = 2;

        }

        private void ultraChart1_DataItemOver(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
            if (!e.Primitive.Empty)
                latestP = e.Primitive as Box;
            MyLabelRenderer.OverLegend(e.Primitive is Box && !string.IsNullOrEmpty(e.Primitive.Path) && e.Primitive.Path.ToLower() == "legend");

        }


        private void ultraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
        {
            if (e.Primitive is Box && !string.IsNullOrEmpty(e.Primitive.Path) && e.Primitive.Path.ToLower() == "legend")
                e.Primitive.Caps = PCaps.HitTest | PCaps.Tooltip;
               
            if (e.Primitive.Series == null || latestP== null || latestP.Series == null)
                return;

            if ( e.Primitive.Series.Label == latestP.Series.Label)
            {
                e.Primitive.PE.Fill = Color.Gray;
                e.Primitive.PE.FillGradientStyle = GradientStyle.None;
            }
                

        }

        private void ultraChart1_DataItemOut(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
            (ultraChart1 as IChartComponent).Invalidate(CacheLevel.LayerLevelCache);
            latestP = null;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {

            foreach (Primitive p in e.SceneGraph)
            {
                if (p is Box && ((Box)p).DataPoint != null)
                {
                    Box b = p as Box;

                    b.rect = new Rectangle(b.rect.Location, new Size(b.rect.Width - 2 * offset, b.rect.Height));
                    int index = ultraChart1.CompositeChart.Series.IndexOf(b.Series);

                    b.rect.Offset(b.rect.Width * index + offset * index - b.rect.Width * b.Column, 0);
                    
                    // Find the text for this column 
                    Primitive text = e.SceneGraph.Cast<Primitive>().FirstOrDefault(prim => prim is Text && ((Text)prim).Row == b.Row && ((Text)prim).Column == b.Column);
                    if (text != null)
                    {
                        ((Text)text).bounds.Location = new Point(b.rect.X, ((Text)text).bounds.Y);
                    }
                }
            }
        }

        private DataTable GetColumnData()
        {
            DataTable mydata = new DataTable();
            //Define the columns and their names
            mydata.Columns.Add("Series Labels", typeof(string));
            mydata.Columns.Add("Column A", typeof(double));
            mydata.Columns.Add("Column B", typeof(double));

            //Add the rows of data
            mydata.Rows.Add(new Object[] { "Series A", 1, 4 });
            mydata.Rows.Add(new Object[] { "Series B", 3, 6});
            mydata.Rows.Add(new Object[] { "Series C", 5, 8 });
            mydata.Rows.Add(new Object[] { "Series D", 7, 10 });
            return mydata;
        }

        private  NumericSeries GetNumericSeriesBound(string valueColumn)
        {
            NumericSeries series = new NumericSeries();
            series.Label = valueColumn;
            // this code populates the series from an external data source
            DataTable table = GetColumnData();
            series.Data.DataSource = table;
            series.Data.LabelColumn = "Series Labels";
            series.Data.ValueColumn = valueColumn;
            series.DataBind();
            return series;
        }

    }
}
